// pages/coupon/coupon.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    imgUrl: app.globalData.urlStatic,//图片路径
    countNum:0,
    pageShow: false,//是否显示页面  false
    isAppointmentShow: false,//是否显示预约弹框
    phoneInputShow: false,//是否显示电话输入框
    siteSelect: false,//是否显示位置选择框
    provinceDataAll: null,//地区所有数据
    provinceDataArr: [[""], [""]],//省市数据
    provinceDataValue: [0, 0],//选中的省市下标
    nowProvince: "",//选中的省市文字
    storeArr: [],//专营店数据
    storeValue: 0,//选中的专营店下标
    verificationCode: '获取验证码',//验证码文案
    sendCode: true,
    appointment: true,
    subscribeData: {
      realname: "",//姓名
      mobile: "",//手机号
      captcha: "",//验证码
      province: "",//省份
      city:"",//城市
      agent_code: "",//经销商编码
      agentDetail: "",//经销商详细信息
      parentOpenid: app.globalData.parentOpenid,//好友openid
    },
    submitSuccess:false,
    placing:false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options.scene) {
      this.data.subscribeData.parentOpenid = options.scene;
      wx.setStorageSync("parentOpenid", options.scene);
      app.globalData.parentOpenid = options.scene;
    }
    if (app.globalData.openid) {
      this.loadFun();
    } else {
      app.globalData.openidSuccessFuc = this.loadFun;
    }
  },
  loadFun:function(){
    if (this.data.subscribeData.parentOpenid == app.globalData.openid){
      wx.reLaunch({
        url: '/pages/index/index',
      })
    } else {
      this.getOrderInfo(); 
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    app.globalData.nowPage = '0';
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return app.sharePack();
  },
  receive: function () {//立即领取
    wx.reLaunch({
      url: '/pages/index/index',
    })
  },
  getOrderInfo: function () {//查询是否已注册
    app.wxRequest(app.globalData.urlRoot +"userInfo/getOrderInfo",{},res=>{
      if(res.code==200){
        if(res.data){
          wx.reLaunch({
            url: '/pages/index/index',
          })
          // this.setData({
          //   pageShow: true
          // })
        }else{
          this.setData({
            pageShow:true
          })
        }
      }
    },this)
  },
  cutPage:function(){//发现启辰星
    wx.reLaunch({
      url: '/pages/index/index',
    })
  },
  showAppointment:function(){
    this.placingControl();
  },
  getUserPhone: function (e) {//获取用户手机号
    this.setData({
      phoneInputShow: true
    })
    if (e.detail.errMsg == 'getPhoneNumber:ok') {
      app.getMobile(e.detail.encryptedData, e.detail.iv, res => {
        if (res.code == 200) {
          if (res.data && res.data.decodeData) {
            this.data.subscribeData.mobile = res.data.decodeData.phoneNumber;
            this.setData({
              subscribeData: this.data.subscribeData
            })
          }
        } else {
          wx.showToast({
            title: res.msg,
            icon: "none"
          })
        }
      }, this);
    }
  },
  getUserLocation: function (e) {
    wx.getLocation({
      type: 'gcj02',  //
      success: (res) => {
        this.getDistributorList(res.longitude, res.latitude);
      },
      fail: (res) => {
        this.getDistributorList("", "");
      },
      complete: (res) => {
        this.setData({
          isAppointmentShow: true
        })
      }
    })
  },
  getDistributorList: function (longitude, latitude) {//获取经销商列表
    app.wxRequest(app.globalData.urlRoot + "agent/getAgentList", { longitude: longitude, latitude: latitude }, res => {
      if (res.code == 200) {
        //整理数据
        var datas = res.data;
        var province = [];
        var city = [];
        for (let i = 0; i < res.data.list.length; i++) {
          province.push(res.data.list[i].province);
        }
        for (let j = 0; j < res.data.list[res.data.nearData.provinceIndex].children.length; j++) {
          city.push(res.data.list[res.data.nearData.provinceIndex].children[j].city)
        }
        //将数据赋值给变量
        this.setData({
          provinceDataAll: res.data.list,
          provinceDataArr: [province, city],
          provinceDataValue: [res.data.nearData.provinceIndex, res.data.nearData.cityIndex],
          nowProvince: province[res.data.nearData.provinceIndex] + " " + city[res.data.nearData.cityIndex],
          storeArr: res.data.list[res.data.nearData.provinceIndex].children[res.data.nearData.cityIndex].children,
          storeValue: res.data.nearData.agentIndex
        })
      } else {
        wx.showToast({
          title: res.msg,
          icon: "none"
        })
      }
    }, this);
  },
  getCode: function (e) {//获取验证码
    if (!app.mobileVerify(this.data.subscribeData.mobile)) {
      if (this.data.subscribeData.mobile) {
        wx.showToast({
          title: '请输入正确的电话',
          icon: 'none'
        })
      } else {
        wx.showToast({
          title: '请输入电话',
          icon: 'none'
        })
      }
      return;
    }
    if (!this.data.sendCode) {
      return;
    }
    this.data.sendCode = false;
    app.wxRequest(app.globalData.urlRoot + "captcha/sendCaptcha", { mobile: this.data.subscribeData.mobile }, res => {
      if (res.code == 200) {
        this.countDown();
        wx.showToast({
          title: '验证码获取成功',
          icon: "none"
        })
        this.setData({
          verificationCode: 60
        })
      } else {
        this.data.sendCode = true;
        wx.showToast({
          title: res.msg,
          icon: "none"
        })
      }
    }, this)
  },
  countDown: function () {//倒计时
    setTimeout(() => {
      this.setData({
        verificationCode: this.data.verificationCode - 1
      })
      if (this.data.verificationCode > 0) {
        this.countDown();
      } else {
        this.setData({
          verificationCode: "获取验证码"
        })
        this.data.sendCode = true;
      }
    }, 1000);
  },
  getRealname: function (e) {//获取用户输入的姓名
    this.data.subscribeData.realname = e.detail.value;
  },
  getMobile: function (e) {//获取用户输入的电话
    this.data.subscribeData.mobile = e.detail.value;
  },
  getCaptcha: function (e) {//获取用户输入的验证码
    this.data.subscribeData.captcha = e.detail.value;
  },
  subscribeFun: function (e) {//预约鉴赏
    if (!this.data.subscribeData.realname) {
      wx.showToast({
        title: '请输入姓名',
        icon: "none"
      })
      return;
    }
    if (!this.data.subscribeData.mobile) {
      wx.showToast({
        title: '请输入电话',
        icon: "none"
      })
      return;
    }
    if (!this.data.subscribeData.captcha) {
      wx.showToast({
        title: '请输入验证码',
        icon: "none"
      })
      return;
    }
    if (!this.data.appointment) {
      return;
    }
    this.data.appointment = false;
    this.data.subscribeData.province = this.data.provinceDataArr[0][this.data.provinceDataValue[0]];
    this.data.subscribeData.city = this.data.provinceDataArr[1][this.data.provinceDataValue[1]];
    this.data.subscribeData.agent_code = this.data.storeArr[this.data.storeValue].agent_code;
    this.data.subscribeData.agentDetail = this.data.storeArr[this.data.storeValue].agent_detail;
    app.wxRequest(app.globalData.urlRoot + "userInfo/submitOrderInfo", this.data.subscribeData, res => {
      this.data.appointment = true;
      if (res.code == 200) {
        app.globalData.userMobile = this.data.subscribeData.mobile;
        this.setData({
          submitSuccess:true
        })
      } else {
        wx.showToast({
          title: res.msg,
          icon: "none"
        })
      }
    }, this, "POST")
  },
  getUserWxMsg: function (e) {
    if (e.detail.errMsg == "getUserInfo:ok") {
      this.setData({
        userData: e.detail.userInfo
      })
      app.submitUserMsg(e.detail.userInfo.avatarUrl, e.detail.userInfo.nickName);
    }
  },
  showSite: function () {//显示地址选择框
    if (!this.data.siteSelect) {
      
    }
  },
  controlWindow: function () {
    this.setData({
      submitSuccess: !this.data.submitSuccess
    })
  },
  provinceDataChange: function (e) {
    if (e.detail.column == 0) {
      var city = [];
      for (let i = 0; i < this.data.provinceDataAll[e.detail.value].children.length; i++) {
        city.push(this.data.provinceDataAll[e.detail.value].children[i].city);
      }
      this.data.provinceDataArr[1] = city;
      this.setData({
        provinceDataArr: this.data.provinceDataArr
      })
    }
  },
  provinceDataChane: function (e) {
    this.setData({
      provinceDataValue: e.detail.value,
      nowProvince: this.data.provinceDataArr[0][e.detail.value[0]] + " " + this.data.provinceDataArr[1][e.detail.value[1]],
      storeArr: this.data.provinceDataAll[e.detail.value[0]].children[e.detail.value[1]].children,
      storeValue: 0
    })
  },
  storeChane: function (e) {
    this.setData({
      storeValue: e.detail.value
    })
  },
  placingControl:function(){
    this.setData({
      placing: !this.data.placing
    })
  }
})