// pages/guessPrize/guessPrize.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    imgUrl: app.globalData.urlStatic,//图片路径
    ruleShow:false,//是否显示规则
    yuyueShow:false,//是否显示预约
    firstPrice:false,//是否有首轮竞猜价格
    httpState:false,//是否正在进行http请求
    guessPrice:123456,//竞猜价格
    guessPriceArr:['1','2','3','4','5','6'],
    shareShow:false,//是否显示分享弹窗
    slideState:false,//滑动状态
    slideNum:0,//滑动距离
    slideDay:['0','0'],//距离上市时间
    submitBefore:true,//提交预测价格之前
    inputValue:"",//输入的价格
    stringValue:"",
    tipWindow:false,//是否显示价格超出的提示弹窗
    tipWindow2:false,
    focusState:false,
    tipImgShow:true,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    app.globalData.nowPage = 3;
    // this.distanceDay();
    if (app.globalData.openid) {
      this.loadFun();
    } else {
      app.globalData.openidSuccessFuc = this.loadFun;
    }
  },
  loadFun:function(){
    this.getFirstGuessInfo();
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '召唤预言帝！快来和我一起猜启辰星售价，赢升舱大奖！',
      imageUrl: this.data.imgUrl + "/versions/guessShareImg.jpg",
      path: "/pages/guess/guess"
    }
  }, 
  ruleControl:function(){//规则显示控制
    this.setData({
      ruleShow:!this.data.ruleShow
    })
  },
  shareWindowControl:function(){//邀请好友弹窗显示控制
    this.setData({
      shareShow:!this.data.shareShow
    })
  },
  lookConfigure:function(){//查看车型详细参数
    wx.navigateTo({
      url: '/pages/configure/configure',
    })
  },
  enterLucky:function(){//每日抽奖
    wx.navigateTo({
      url: '/pages/luckyStar/luckyStar'
    })
  },
  yuyueControl:function(){//预约
    this.setData({
      yuyueShow: !this.data.yuyueShow
    })
  },
  getFirstGuessInfo:function(){//获取首轮竞猜价格信息
    app.wxRequest(app.globalData.urlRoot + "guessPrice/getFirstGuessInfo", {}, res => {
      // res.data = null;
      if (res.code == 200 && res.data) {
        this.data.guessPriceArr = res.data.guess_price.toString().split("");
        for(let i=0;i<this.data.guessPriceArr.length;i++){
          this.data.guessPriceArr[i] = parseInt(this.data.guessPriceArr[i]);
        }
        this.setData({
          submitBefore:false,
          firstPrice:true,
          guessPriceArr:this.data.guessPriceArr
        })
      }
    }, this);
  },
  submitPrice:function(){
    if(this.data.firstPrice){
      this.shareWindowControl();
    }else{
      this.submitFirstGuessInfo();
    }
  },
  submitFirstGuessInfo:function(){//提交首轮竞猜价格
    if(this.data.httpState){
      return;
    }
    this.data.httpState = true;
    app.wxRequest(app.globalData.urlRoot + "guessPrice/submitFirstGuessInfo", {guess_price:this.data.guessPrice,statistics_scene:app.globalData.sceneSource}, res => {
      this.data.httpState = false;
      if (res.code == 200) {
        this.setData({
          submitBefore:false,
          firstPrice:true
        })
        this.tipWindowControl2();
        this.shareWindowControl();
      }else{
        wx.showToast({
          title: res.msg,
          icon:"none"
        })
      }
    }, this,"POST");
  },
  stratMove:function(e){
    var index = e.currentTarget.dataset.index;
    if(index == 0){
      return;
    }
    this.setData({
      slideState:true
    })
    console.log(e);
    this.data.slideNum = e.changedTouches[0].pageY;
  },
  endMove:function(e){
    var index = e.currentTarget.dataset.index;
    if(index == 0){
      return;
    }
    this.setData({
      slideState:false
    })
    if(e.changedTouches[0].pageY-this.data.slideNum>=10){
      console.log("往下滑");
      if(index==1){
        this.data.guessPrice-=10000;
      }else if(index==2){
        this.data.guessPrice-=1000;
      }else if(index==3){
        this.data.guessPrice-=100;
      }else if(index==4){
        this.data.guessPrice-=10;
      }else if(index==5){
        this.data.guessPrice-=1;
      }
      if(this.data.guessPrice<110000){
        this.data.guessPrice = 110000;
      }
      this.data.guessPriceArr = this.data.guessPrice.toString().split("");
      for(let i=0;i<this.data.guessPriceArr.length;i++){
        this.data.guessPriceArr[i] = parseInt(this.data.guessPriceArr[i]);
      }
      this.setData({
        guessPriceArr:this.data.guessPriceArr
      })
    }else if(e.changedTouches[0].pageY+10<=this.data.slideNum){
      console.log("往上滑");
      if(index==1){
        this.data.guessPrice+=10000;
      }else if(index==2){
        this.data.guessPrice+=1000;
      }else if(index==3){
        this.data.guessPrice+=100;
      }else if(index==4){
        this.data.guessPrice+=10;
      }else if(index==5){
        this.data.guessPrice+=1;
      }
      if(this.data.guessPrice>150000){
        this.data.guessPrice = 150000;
      }
      this.data.guessPriceArr = this.data.guessPrice.toString().split("");
      for(let i=0;i<this.data.guessPriceArr.length;i++){
        this.data.guessPriceArr[i] = parseInt(this.data.guessPriceArr[i]);
      }
      this.setData({
        guessPriceArr:this.data.guessPriceArr
      })
    }
  },
  distanceDay:function(){//距离4月23日上市还有XX天
    var timestamp = Date.parse(new Date()); //今天的时间戳
    var timestamp2 = Date.parse(new Date('2020-04-23')); //上市时间时间戳
    if(timestamp2>timestamp){
      var slideNum = Math.ceil((timestamp2-timestamp)/60/60/24/1000).toString().split("");
      this.setData({
        slideDay:slideNum//距离上市时间
      })
    }
  },
  getValue:function(e){
    this.data.inputValue = e.detail.value;
    if(e.detail.value){
      this.setData({
        tipImgShow:false
      })
    }else{
      this.setData({
        tipImgShow:true
      })
    }
    this.setData({
      stringValue:e.detail.value
    })
  },
  submitPrice2:function(){
    if(this.data.inputValue>150000 || this.data.inputValue<110000){
      this.tipWindowControl();
    }else{
      this.data.guessPrice = this.data.inputValue;
      this.data.guessPriceArr = this.data.guessPrice.toString().split("");
      for(let i=0;i<this.data.guessPriceArr.length;i++){
        this.data.guessPriceArr[i] = parseInt(this.data.guessPriceArr[i]);
      }
      this.setData({
        guessPriceArr:this.data.guessPriceArr
      })
      console.log(this.data.guessPrice);
      console.log(this.data.guessPriceArr);
      this.tipWindowControl2();
    }
    // this.submitFirstGuessInfo();
  },
  tipWindowControl:function(){
    this.setData({
      tipWindow:!this.data.tipWindow
    })
    if(!this.data.tipWindow){
      this.setData({
        stringValue:"",
        tipImgShow:true
      })
    }
  },
  tipWindowControl2:function(){
    this.setData({
      tipWindow2:!this.data.tipWindow2
    })
  },
  tipWindowControl3:function(){
    this.setData({
      stringValue:"",
      tipImgShow:true
    })
    this.setData({
      tipWindow2:!this.data.tipWindow2
    })
  },
  focusControl:function(){
    this.setData({
      focusState:true
    })
  },
  focusControl2:function(){
    this.setData({
      focusState:false
    })
  }
})